<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd"><html xmlns="http://www.w3.org/1999/xhtml"><head><link rel="stylesheet" type="text/css" href="style.css" /><script type="text/javascript" src="highlight.js"></script></head><body><pre><span class="hs-keyword">module</span><span> </span><span class="hs-identifier">Neo4J.Conversion</span><span> </span><span class="hs-special">(</span><span class="annot"><a href="Neo4J.Conversion.html#nodeToLexis"><span class="hs-identifier">nodeToLexis</span></a></span><span class="hs-special">)</span><span> </span><span class="hs-keyword">where</span><span>
</span><span id="line-2"></span><span>
</span><span id="line-3"></span><span class="hs-keyword">import</span><span> </span><span class="hs-keyword">qualified</span><span> </span><span class="annot"><span class="hs-identifier">Data.Text</span></span><span> </span><span class="hs-keyword">as</span><span> </span><span class="annot"><span class="hs-identifier">T</span></span><span>
</span><span id="line-4"></span><span class="hs-keyword">import</span><span> </span><span class="annot"><span class="hs-identifier">Database.Bolt</span></span><span>
</span><span id="line-5"></span><span class="hs-keyword">import</span><span> </span><span class="annot"><a href="EuskeraAppError.html"><span class="hs-identifier">EuskeraAppError</span></a></span><span>
</span><span id="line-6"></span><span class="hs-keyword">import</span><span> </span><span class="annot"><a href="Lexis.html"><span class="hs-identifier">Lexis</span></a></span><span>
</span><span id="line-7"></span><span class="hs-keyword">import</span><span> </span><span class="annot"><a href="Neo4J.Conversion.Adjective.html"><span class="hs-identifier">Neo4J.Conversion.Adjective</span></a></span><span>
</span><span id="line-8"></span><span class="hs-keyword">import</span><span> </span><span class="annot"><a href="Neo4J.Conversion.Noun.html"><span class="hs-identifier">Neo4J.Conversion.Noun</span></a></span><span>
</span><span id="line-9"></span><span class="hs-keyword">import</span><span> </span><span class="annot"><a href="Neo4J.Conversion.Utils.html"><span class="hs-identifier">Neo4J.Conversion.Utils</span></a></span><span>
</span><span id="line-10"></span><span class="hs-keyword">import</span><span> </span><span class="annot"><a href="Neo4J.Conversion.Verb.html"><span class="hs-identifier">Neo4J.Conversion.Verb</span></a></span><span>
</span><span id="line-11"></span><span>
</span><span id="line-12"></span><span class="hs-comment">-- | Use node information to create a Lexis of the appropriate type</span><span>
</span><span id="line-13"></span><span class="hs-comment">-- with default features</span><span>
</span><span id="line-14"></span><span class="annot"><a href="Neo4J.Conversion.html#nodeToLexis"><span class="hs-identifier hs-type">nodeToLexis</span></a></span><span> </span><span class="hs-glyph">::</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Node</span></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Either</span></span><span> </span><span class="annot"><a href="EuskeraAppError.html#EuskeraAppError"><span class="hs-identifier hs-type">EuskeraAppError</span></a></span><span> </span><span class="annot"><a href="Lexis.html#Lexis"><span class="hs-identifier hs-type">Lexis</span></a></span><span>
</span><span id="line-15"></span><span id="nodeToLexis"><span class="annot"><span class="annottext">nodeToLexis :: Node -&gt; Either EuskeraAppError Lexis
</span><a href="Neo4J.Conversion.html#nodeToLexis"><span class="hs-identifier hs-var hs-var">nodeToLexis</span></a></span></span><span> </span><span id="local-6989586621679082610"><span class="annot"><span class="annottext">Node
</span><a href="#local-6989586621679082610"><span class="hs-identifier hs-var">node</span></a></span></span><span>
</span><span id="line-16"></span><span>  </span><span class="hs-glyph">|</span><span> </span><span class="annot"><span class="annottext">Node -&gt; String
</span><a href="Neo4J.Conversion.Utils.html#getRoot"><span class="hs-identifier hs-var">getRoot</span></a></span><span> </span><span class="annot"><span class="annottext">Node
</span><a href="#local-6989586621679082610"><span class="hs-identifier hs-var">node</span></a></span><span> </span><span class="annot"><span class="annottext">String -&gt; String -&gt; Bool
forall a. Eq a =&gt; a -&gt; a -&gt; Bool
</span><span class="hs-operator hs-var">==</span></span><span> </span><span class="annot"><span class="annottext">String
</span><span class="hs-string">&quot;&quot;</span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">Node -&gt; Either EuskeraAppError Lexis
</span><a href="Neo4J.Conversion.Utils.html#conversionError"><span class="hs-identifier hs-var">conversionError</span></a></span><span> </span><span class="annot"><span class="annottext">Node
</span><a href="#local-6989586621679082610"><span class="hs-identifier hs-var">node</span></a></span><span>
</span><span id="line-17"></span><span>  </span><span class="hs-glyph">|</span><span> </span><span class="annot"><span class="annottext">String
</span><span class="hs-string">&quot;Anthroponym&quot;</span></span><span> </span><span class="annot"><span class="annottext">String -&gt; [String] -&gt; Bool
forall (t :: * -&gt; *) a. (Foldable t, Eq a) =&gt; a -&gt; t a -&gt; Bool
</span><span class="hs-operator hs-var">`elem`</span></span><span> </span><span class="annot"><span class="annottext">[String]
</span><a href="#local-6989586621679082606"><span class="hs-identifier hs-var">wordclass</span></a></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">Node -&gt; Either EuskeraAppError Lexis
</span><a href="Neo4J.Conversion.Noun.html#createAnthroponym"><span class="hs-identifier hs-var">createAnthroponym</span></a></span><span> </span><span class="annot"><span class="annottext">Node
</span><a href="#local-6989586621679082610"><span class="hs-identifier hs-var">node</span></a></span><span>
</span><span id="line-18"></span><span>  </span><span class="hs-glyph">|</span><span> </span><span class="annot"><span class="annottext">String
</span><span class="hs-string">&quot;Common&quot;</span></span><span> </span><span class="annot"><span class="annottext">String -&gt; [String] -&gt; Bool
forall (t :: * -&gt; *) a. (Foldable t, Eq a) =&gt; a -&gt; t a -&gt; Bool
</span><span class="hs-operator hs-var">`elem`</span></span><span> </span><span class="annot"><span class="annottext">[String]
</span><a href="#local-6989586621679082606"><span class="hs-identifier hs-var">wordclass</span></a></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">Node -&gt; Either EuskeraAppError Lexis
</span><a href="Neo4J.Conversion.Noun.html#createCommonNoun"><span class="hs-identifier hs-var">createCommonNoun</span></a></span><span> </span><span class="annot"><span class="annottext">Node
</span><a href="#local-6989586621679082610"><span class="hs-identifier hs-var">node</span></a></span><span>
</span><span id="line-19"></span><span>  </span><span class="hs-glyph">|</span><span> </span><span class="annot"><span class="annottext">String
</span><span class="hs-string">&quot;Mass&quot;</span></span><span> </span><span class="annot"><span class="annottext">String -&gt; [String] -&gt; Bool
forall (t :: * -&gt; *) a. (Foldable t, Eq a) =&gt; a -&gt; t a -&gt; Bool
</span><span class="hs-operator hs-var">`elem`</span></span><span> </span><span class="annot"><span class="annottext">[String]
</span><a href="#local-6989586621679082606"><span class="hs-identifier hs-var">wordclass</span></a></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">Node -&gt; Either EuskeraAppError Lexis
</span><a href="Neo4J.Conversion.Noun.html#createMassNoun"><span class="hs-identifier hs-var">createMassNoun</span></a></span><span> </span><span class="annot"><span class="annottext">Node
</span><a href="#local-6989586621679082610"><span class="hs-identifier hs-var">node</span></a></span><span>
</span><span id="line-20"></span><span>  </span><span class="hs-glyph">|</span><span> </span><span class="annot"><span class="annottext">String
</span><span class="hs-string">&quot;Adjective&quot;</span></span><span> </span><span class="annot"><span class="annottext">String -&gt; [String] -&gt; Bool
forall (t :: * -&gt; *) a. (Foldable t, Eq a) =&gt; a -&gt; t a -&gt; Bool
</span><span class="hs-operator hs-var">`elem`</span></span><span> </span><span class="annot"><span class="annottext">[String]
</span><a href="#local-6989586621679082606"><span class="hs-identifier hs-var">wordclass</span></a></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">Node -&gt; Either EuskeraAppError Lexis
</span><a href="Neo4J.Conversion.Adjective.html#createQualitativeAdjective"><span class="hs-identifier hs-var">createQualitativeAdjective</span></a></span><span> </span><span class="annot"><span class="annottext">Node
</span><a href="#local-6989586621679082610"><span class="hs-identifier hs-var">node</span></a></span><span>
</span><span id="line-21"></span><span>  </span><span class="hs-glyph">|</span><span> </span><span class="annot"><span class="annottext">String
</span><span class="hs-string">&quot;NorNork&quot;</span></span><span> </span><span class="annot"><span class="annottext">String -&gt; [String] -&gt; Bool
forall (t :: * -&gt; *) a. (Foldable t, Eq a) =&gt; a -&gt; t a -&gt; Bool
</span><span class="hs-operator hs-var">`elem`</span></span><span> </span><span class="annot"><span class="annottext">[String]
</span><a href="#local-6989586621679082606"><span class="hs-identifier hs-var">wordclass</span></a></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">Node -&gt; Either EuskeraAppError Lexis
</span><a href="Neo4J.Conversion.Verb.html#createNorNorkVerb"><span class="hs-identifier hs-var">createNorNorkVerb</span></a></span><span> </span><span class="annot"><span class="annottext">Node
</span><a href="#local-6989586621679082610"><span class="hs-identifier hs-var">node</span></a></span><span>
</span><span id="line-22"></span><span>  </span><span class="hs-glyph">|</span><span> </span><span class="annot"><span class="annottext">Bool
</span><span class="hs-identifier hs-var">otherwise</span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">EuskeraAppError -&gt; Either EuskeraAppError Lexis
forall a b. a -&gt; Either a b
</span><span class="hs-identifier hs-var">Left</span></span><span> </span><span class="annot"><span class="annottext">EuskeraAppError
</span><a href="EuskeraAppError.html#Unimplemented"><span class="hs-identifier hs-var">Unimplemented</span></a></span><span>
</span><span id="line-23"></span><span>  </span><span class="hs-keyword">where</span><span>
</span><span id="line-24"></span><span>    </span><span id="local-6989586621679082606"><span class="annot"><span class="annottext">wordclass :: [String]
</span><a href="#local-6989586621679082606"><span class="hs-identifier hs-var hs-var">wordclass</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">Text -&gt; String
</span><span class="hs-identifier hs-var">T.unpack</span></span><span> </span><span class="annot"><span class="annottext">(Text -&gt; String) -&gt; [Text] -&gt; [String]
forall (f :: * -&gt; *) a b. Functor f =&gt; (a -&gt; b) -&gt; f a -&gt; f b
</span><span class="hs-operator hs-var">&lt;$&gt;</span></span><span> </span><span class="annot"><span class="annottext">Node -&gt; [Text]
</span><span class="hs-identifier hs-var hs-var">labels</span></span><span> </span><span class="annot"><span class="annottext">Node
</span><a href="#local-6989586621679082610"><span class="hs-identifier hs-var">node</span></a></span><span>
</span><span id="line-25"></span></pre></body></html>